10  input "input data from ichan" ichan%
' tbatod returns 1 a/d value on ichan% to ival1%
' the number will be a 12 bit integer and must be
' properly modified to give a voltage value
' for example with the +/-10 volt range:
'   v=(10./4096)*(ival1%-2048)
    call tbatod(ival1%,ichan%)
    print "ival1,ichan",ival1%,ichan%
'
20  input "output",ival1%: input "to ichan",ichan%
' tbdtoa puts out the value ival1% to d/a channel ichan%
' the value must be set up for the range.  For an output
' range of +/-10 volts the value is
'    ival1%= v*(4096/10.)+2048
' note that the largest values must be limited to 0 (-10.volts)
'    to 4095 (approximately 9.995 volts)
    call tbdtoa(ival1%,ichan%)
    print "output made"
'
    input "digital output",ival1%
' tbdgou puts the 16 bit word ival1% to the digital output port
    call tbdgou(ival1%)
'
    input "press return to read digital input",ival1%
'
    call tbdgin(ival1%)
    print "dig val:",ival1%
'
'  tbsetc and tbwatc can be used to make
'  counters 0 and 1 on the daca board into a pacer
'  clock. tbsetc sets the time delay between "tics" of
'  the clock with tdelay=id0%*id1%/(1.023e6)
'  In the simple way that tbwatc is written you must:
'     make id1% >200 and must check yourself
'     that your computer can finish the necessary work
'     that you expect to have finished in one clock tic
'     If your program misses a tic, tbwatc will wait for the
;     next one
    input "id0,id1:",id0%,id1%
    call tbsetc(id0%,id1%)
    for i=1 to 10
100 call tbwatc
    print "done",i
    next i
    print "program terminated"
    stop
' INLINE ASSEMBLER ROUTINE 
SUB tbwatc
    icatch%=100
310  out &HB2E2,&H44
    ilo=inp(&H92E2)
    ihi=inp(&H92E2)
    if ihi > 0 goto 310
    if ilo >= icatch% goto 310
320  out &HB2E2,&H44
    ilo=inp(&H92E2)
    ihi=inp(&H92E2)
    itot=ihi*256+ilo
    if itot <= icatch% goto 320
END SUB
SUB tbatod INLINE ' (ival1%,ichan%)
$INLINE "TBATOD.BIN"
END SUB
SUB tbdtoa INLINE ' (ival1%,ichan%)
$INLINE "TBDTOA.BIN"
END SUB
SUB tbdgin INLINE ' (ival1%)
$INLINE "TBDGIN.BIN"
END SUB
SUB tbdgou INLINE ' (ival1%)
$INLINE "TBDGOU.BIN"
END SUB
SUB tbsetc INLINE ' (id0%,id1%) delay is id0%*id1%*(1/1.023e6)
$INLINE "TBSETC.BIN"
END SUB
