c this declares the usual integers as *2 instead of *4
          implicit integer*2 (i-n)
c this declares the arrays storing the labels as character*1
       character*1 bpv1la,bph1la,bpt1la,
     $             bpv2la,bph2la,bpt2la,
     $             bpv3la,bph3la,bpt3la,
     $             bpv4la,bph4la,bpt4la,
     $             bhead1,bhead2
          parameter (n41=4096)
c this common holds the actual data for each of the traces.
      common/mdatf1/VERT1(n41),HORZ1(n41),TIME1(n41)
      common/mdatf2/VERT2(n41),HORZ2(n41),TIME2(n41)
      common/mdatf3/VERT3(n41),HORZ3(n41),TIME3(n41)
      common/mdatf4/VERT4(n41),HORZ4(n41),TIME4(n41)
c this common holds the number of channels and the number of
c      data points in each trace
          common/mdatan/nchd,npt1,npt2,npt3,npt4
c this common holds the labels for the traces
c      for example bpv1la is the label for vertical trace 1
          common/mdatal/
     $ bpv1la(20),bph1la(20),bpt1la(20),
     $ bpv2la(20),bph2la(20),bpt2la(20),
     $ bpv3la(20),bph3la(20),bpt3la(20),
     $ bpv4la(20),bph4la(20),bpt4la(20)
          common/mdatah/
     $ bhead1(40),bhead2(40)
c this common holds numbers used for input and output. DONOT change them
       common/munits/luset,ludis,lsio1,lsio2,lsio3,lsio4
c this common holds the names used to access the data files. DONOT change them
       common/mnames/bfinp(10),bfout(10)
c now starts the program
c setup initial values
        call init(n41)
c this program will convert UnkelScope binary files of the form XXXX##.bin
c   and into ascii files of the format XXXX##.txt
c          where XXXX is the basic file name
c                  ## is the file number and can be any ascii number from 00
c                     to 99
c
c put in most of the input and output names
      call bstuf(10,bfinp,'XXXX00.bin')
      call bstuf(10,bfout,'XXXX00.txt')
c now read in the first 4 characters of the name over the others
      write(*,8000)
8000  format(' Type first 4 characters of name:',$)
      read(*,8001)(bfinp(i),i=1,4)
8001  format(4a1)
      do 850 i=1,4
         bfout(i)=bfinp(i)
850   continue
c now read in the highest ## of file to be tried
      write(*,8100)
8100  format(' Look for files from 00 to :',$)
      read(*,*)ifilmx
c set file types - binary input, ascii output
      nin=1
      nout=2
c now loop for all possible files
      do 851 i=1,ifilmx
         ifil=i-1
         itens=ifil/10
         bfinp(5)=char(48+itens)
         bfout(5)=bfinp(5)
         iones=ifil-10*itens
         bfinp(6)=char(48+iones)
         bfout(6)=bfinp(6)
c put message on screen
         write(*,8002)bfinp,bfout
8002     format(' Working on file:',10a1,' to ',10a1, 'Translation')
         call binput(nin,maxch,maxlen,ner)
         if (ner .eq. 0) call boutpu(nout,maxch,maxlen,ner)
851   continue
      stop
      end
